Summary: Practical Extraction and Report Language
Name: perl
%define perlver 5.004
%define perlrel 05
Version: %{perlver}m7
Release: 2
Copyright: GPL
Group: Utilities/Text
Source0: ftp://ftp.perl.org/pub/perl/CPAN/src/5.0/maint/perl%{perlver}_%{perlrel}-MAINT_TRIAL_7.tar.gz
Source1: listh2phfiles
Patch0: perl5.004_04-buildsys.patch
Patch1: perl5.004_04-syslog.patch
Requires: csh
Buildroot: %{_tmppath}/perl-root
Summary(de): Praktische Extraktions- und Berichtsprache 
Summary(fr): Practical Extraction and Report Language (Perl)
Summary(tr): Kabuk yorumlama dili

%description
Perl is an interpreted language optimized for scanning arbitrary text
files, extracting information from those text files, and printing reports
based on that information.  It's also a good language for many system
management tasks.  The language is intended to be practical (easy to use,
efficient, complete) rather than beautiful (tiny, elegant, minimal).

%description -l de
Perl ist eine Interpreter-Sprache, die zum Durchsuchen beliebiger Text-
dateien, Extrahieren von Informationen aus diesen Dateien und Drucken von
auf diesen Informationen basierenden Berichten optimiert ist. Die Sprache
eignet sich auerdem fr viele Systemverwaltungsaufgaben. Sie ist eher 
praktisch (einfache Anwendung,effizient, vollstndig) als schn (winzig,
elegant, minimal).

%description -l fr
Perl est un langage interprt, optimis pour filtrer des fichiers texte,
extraire des informations de ces fichiers, et imprimer des rapports bass
sur ces informations. C'est aussi un bon langage pour de nombreuses procdures
de gestion systme. Ce langage se veut pratique (simple  utiliser, efficace,
complet) autant qu'agrable (conscrit, lgant, minimal).

%description -l tr
Perl, metin dosyalarn taramak, bu metin dosyalarndan bilgi karmak ve
bu bilgiye dayal raporlar hazrlamak icin gelitirilmi bir yorumlamal
dildir. Ayrca pek ok sistem ynetimi grevleri iin de yararl yetenekleri
vardr. Perl, gzel (ufak, zarif, minimum) olmaktan ok, pratik olmaya
ynelik (kullanm kolay, verimli, eksiksiz) olarak tasarlanmtr.

%prep
%setup -q -n perl%{perlver}_%{perlrel}-MAINT_TRIAL_7 
%patch0 -p1 -b .buildsys
%patch1 -p1 -b .syslog

%build
# this is gross
cat > config.over <<EOF
installprefix=$RPM_BUILD_ROOT/usr
test -d \$installprefix || mkdir \$installprefix
test -d \$installprefix/bin || mkdir \$installprefix/bin
installarchlib=\`echo \$installarchlib | sed "s!\$prefix!\$installprefix!"\`
installbin=\`echo \$installbin | sed "s!\$prefix!\$installprefix!"\`
installman1dir=\`echo \$installman1dir | sed "s!\$prefix!\$installprefix!"\`
installman3dir=\`echo \$installman3dir | sed "s!\$prefix!\$installprefix!"\`
installprivlib=\`echo \$installprivlib | sed "s!\$prefix!\$installprefix!"\`
installscript=\`echo \$installscript | sed "s!\$prefix!\$installprefix!"\`
installsitelib=\`echo \$installsitelib | sed "s!\$prefix!\$installprefix!"\`
installsitearch=\`echo \$installsitearch | sed "s!\$prefix!\$installprefix!"\`
EOF

sh Configure -des -Dprefix=/usr -Darchname=${RPM_ARCH}-linux -Dd_dosuid \
	-Ud_setresuid -Ud_setresgid -Dd_semctl_semun -Di_syslog

make

# Strip binaries (done now rather than at install)
strip perl
strip suidperl
strip x2p/a2p

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
make install
install -m 755 utils/pl2pm $RPM_BUILD_ROOT/usr/bin/pl2pm

# Generate *.ph files
( cd /usr/include ; 
  PERL5LIB=$RPM_BUILD_ROOT/usr/lib/perl5 $RPM_BUILD_ROOT/usr/bin/perl \
    $RPM_BUILD_ROOT/usr/bin/h2ph \
      -d $RPM_BUILD_ROOT/usr/lib/perl5/${RPM_ARCH}-linux/%{perlver}%{perlrel}/ \
	`sh $RPM_SOURCE_DIR/listh2phfiles` linux/*.h asm/*.h scsi/*.h
) # end cd usr/include

# need stdarg.h from gcc shadow to fix "use Sys::Syslog"
( cd `/usr/bin/gcc --print-file-name include`
  PERL5LIB=$RPM_BUILD_ROOT/usr/lib/perl5 $RPM_BUILD_ROOT/usr/bin/perl \
    $RPM_BUILD_ROOT/usr/bin/h2ph \
      -d $RPM_BUILD_ROOT/usr/lib/perl5/${RPM_ARCH}-linux/%{perlver}%{perlrel}/ \
	`sh $RPM_SOURCE_DIR/listh2phfiles`
)


# Fix the header file that declares NULL...
sed 's/( \&void \*) //' \
$RPM_BUILD_ROOT/usr/lib/perl5/${RPM_ARCH}-linux/%{perlver}%{perlrel}/linux/posix_types.ph > /tmp/$$.change
mv -f /tmp/$$.change $RPM_BUILD_ROOT/usr/lib/perl5/${RPM_ARCH}-linux/%{perlver}%{perlrel}/linux/posix_types.ph

# Fix up Config.pm to remove evidence of our buildroot hack
cd $RPM_BUILD_ROOT//usr/lib/perl5/${RPM_ARCH}-linux/%{perlver}%{perlrel}
mv Config.pm Config.pm.old
sed "s|$RPM_BUILD_ROOT||" < Config.pm.old > Config.pm
rm -f Config.pm.old

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/usr/bin/sperl%{perlver}%{perlrel}
/usr/bin/perl%{perlver}%{perlrel}
/usr/bin/suidperl
/usr/bin/perl
/usr/bin/a2p
/usr/bin/c2ph
/usr/bin/pstruct
/usr/bin/s2p
/usr/bin/find2perl
/usr/bin/h2xs
/usr/bin/h2ph
/usr/bin/pl2pm
/usr/bin/perldoc
/usr/bin/pod2man
/usr/bin/pod2html
/usr/bin/pod2latex
/usr/lib/perl5
/usr/man/man1/a2p.1*
/usr/man/man1/s2p.1*
/usr/man/man1/perl*.1*

%changelog
* Mon Aug  7 2000 Nalin Dahyabhai <nalin@redhat.com>
- use syslog instead of mail to report possible attempts to break into suidperl
- force syslog on at build-time

* Thu Jan 07 1999 Cristian Gafton <gafton@redhat.com>
- upgraded to 5.004_05-MAINT_TRIAL_7

* Wed Sep 09 1998 Preston Brown <pbrown@redhat.com>
- added newer CGI.pm to the build
- changed the version naming scheme around to work with RPM

* Sun Jul 19 1998 Jeff Johnson <jbj@redhat.com>
- attempt to generate *.ph files reproducibly

* Mon Jun 15 1998 Jeff Johnson <jbj@redhat.com>
- update to 5.004_04-m4 (pre-5.005 maintenance release)

* Tue Jun 12 1998 Christopher McCrory <chrismcc@netus.com
- need stdarg.h from gcc shadow to fix "use Sys::Syslog" (problem #635)

* Fri May 08 1998 Cristian Gafton <gafton@redhat.com>
- added a patch to correct the .ph constructs unless defined (foo) to read
  unless(defined(foo))

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Tue Mar 10 1998 Cristian Gafton <gafton@redhat.com>
- fixed strftime problem

* Sun Mar 08 1998 Cristian Gafton <gafton@redhat.com>
- added a patch to fix a security race
- do not use setres[ug]id - those are not implemented on 2.0.3x kernels

* Mon Mar 02 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 5.004_04 - 5.004_01 had some nasty memory leaks.
- fixed the spec file to be version-independent

* Fri Dec 05 1997 Erik Troan <ewt@redhat.com>
- Config.pm wasn't right do to the builtrooting

* Mon Oct 20 1997 Erik Troan <ewt@redhat.com>
- fixed arch-specfic part of spec file

* Sun Oct 19 1997 Erik Troan <ewt@redhat.com>
- updated to perl 5.004_01
- users a build root

* Thu Jun 12 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Apr 22 1997 Erik Troan <ewt@redhat.com>
- Incorporated security patch from Chip Salzenberg <salzench@nielsenmedia.com>

* Fri Feb 07 1997 Erik Troan <ewt@redhat.com>
- Use -Darchname=i386-linux 
- Require csh (for glob)
- Use RPM_ARCH during configuration and installation for arch independence
